/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.30 by edhill, Tue Nov 11 21:11:06 2003 UTC revision 1.98 by edhill, Tue Sep 7 21:28:47 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
243      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
244      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
245      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
253            
254      echo "test" > test      echo "test" > test
255      ln -s ./test link      ln -s ./test link
# Line 104  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # look for possible fortran compilers      look_for_makedepend
271    
272        #================================================================
273        #  look for possible C compilers
274        tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275        p_CC=
276        for c in $tmp ; do
277            rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309        fi
310    
311        #================================================================
312        #  look for possible FORTRAN compilers
313      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
# Line 130  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 139  EOF Line 344  EOF
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 206  get_pdepend_list()  { Line 420  get_pdepend_list()  {
420      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
421          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
422          > ./.pd_tmp          > ./.pd_tmp
423      source ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
430  #  Explain usage  #  Explain usage
431  usage()  {  usage()  {
432      echo  cat <<EOF
433      echo "Usage: "$0" [OPTIONS]"  
434      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
435      echo    where [OPTIONS] can be:
436      echo "    -help | --help | -h | --h"  
437      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
438      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
439      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
440      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
443      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
444      echo "    -make NAME | -m NAME"  
445      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
446      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
448      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
449      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
450      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
451      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
452      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
453      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
454      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
455      echo "      -disable=NAME | --disable=NAME"  
456      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
457      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
458      echo "    -standarddirs NAME | --standarddirs NAME"            Get the default package list from "NAME".
459      echo "      -standarddirs=NAME | --standarddirs=NAME"  
460      echo "    -noopt NAME | --noopt NAME"      -make NAME | -m NAME
461      echo "      -noopt=NAME | --noopt=NAME"        --make=NAME | -m=NAME
462  #    echo "    -cpp NAME | --cpp NAME"            Use "NAME" for the MAKE program. The default is "make" but
463  #    echo "      -cpp=NAME | --cpp=NAME"            many platforms, "gmake" is the preferred choice.
464      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"  
465      echo "      -fc=NAME | --fc=NAME"      -makefile NAME | -mf NAME
466      echo "    -[no]ieee | --[no]ieee"        --makefile=NAME | -mf=NAME
467      echo "    -[no]mpi | --[no]mpi"            Call the makefile "NAME".  The default is "Makefile".
468      echo "    -[no]jam | --[no]jam"  
469      echo      -makedepend NAME | -md NAME
470      echo "  and NAME is a string such as:"        --makedepend=NAME | -md=NAME
471      echo            Use "NAME" for the MAKEDEPEND program.
472      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"  
473      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475      echo            Specify the location of the MITgcm ROOTDIR as "NAME".
476      echo "  which, depending upon your shell, may need to be single-quoted"            By default, genamke will try to find the location by
477      echo "  if it contains spaces, dashes, or other special characters."            looking in parent directories (up to the 5th parent).
478    
479        -mods NAME | --mods NAME | -mo NAME | --mo NAME
480          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
481              Here, "NAME" specifies a list of directories that are
482              used for additional source code.  Files found in the
483              "mods list" are given preference over files of the same
484              name found elsewhere.
485    
486        -disable NAME | --disable NAME
487          -disable=NAME | --disable=NAME
488              Here "NAME" specifies a list of packages that we don't
489              want to use.  If this violates package dependencies,
490              genamke will exit with an error message.
491    
492        -enable NAME | --enable NAME
493          -enable=NAME | --enable=NAME
494              Here "NAME" specifies a list of packages that we wish
495              to specifically enable.  If this violates package
496              dependencies, genamke will exit with an error message.
497    
498        -standarddirs NAME | --standarddirs NAME
499          -standarddirs=NAME | --standarddirs=NAME
500              Here, "NAME" specifies a list of directories to be
501              used as the "standard" code.
502    
503        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
504          -fc=NAME | --fc=NAME
505              Use "NAME" as the fortran compiler.  By default, genmake
506              will search for a working compiler by trying a list of
507              "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514        -[no]ieee | --[no]ieee
515              Do or don't use IEEE numerics.  Note that this option
516              *only* works if it is supported by the OPTFILE that
517              is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529      While it is most often a single word, the "NAME" variables specified
530      above can in many cases be a space-delimited string such as:
531    
532        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
533        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
534        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
535    
536      which, depending upon your shell, may need to be single-quoted.
537    
538      For more detailed genmake documentation, please see:
539    
540        http://mitgcm.org/devel_HOWTO/
541    
542    EOF
543    
544      exit 1      exit 1
545  }  }
546    
547  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
548  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
549  #eh3 set CPP        = ( '/lib/cpp -P' )  
550  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551  #eh3 set KPP        = (  )      if test ! "x$FC_NAMEMANGLE" = x ; then
552  #eh3 set FC         = ( 'f77' )          return 0
553  #eh3 set LINK       = $FC      fi
554  #eh3 set MAKEDEPEND = ( 'makedepend' )  
555  #eh3 set INCLUDES   = ( -I. )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556  #eh3 set FFLAGS     = (  )      
557  #eh3 set FOPTIM     = (  )      cat > genmake_test.c <<EOF
558  #eh3 set CFLAGS     = (  )  void tcall( char * string ) { tsub( string ); }
559  #eh3 set KFLAGS1    = (  )  EOF
560  #eh3 set KFLAGS2    = (  )      $MAKE genmake_test.o >> genmake_warnings 2>&1
561  #eh3 set LIBS       = (  )      RETVAL=$?
562  #eh3 set KPPFILES   = (  )      if test "x$RETVAL" != x0 ; then
563  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          FC_NAMEMANGLE=$default_nm
564  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          cat <<EOF>> genmake_errors
565    
566    WARNING: C test compile fails
567    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
568    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
569    EOF
570            return 1
571        fi
572        c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573        RETVAL=$?
574        if test "x$RETVAL" != x0 ; then
575            FC_NAMEMANGLE=$default_nm
576            cat <<EOF>> genmake_warnings
577    
578    WARNING: The "nm" command failed.
579    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
580    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
581    EOF
582            return 1
583        fi
584        cat > genmake_tcomp.f <<EOF
585          subroutine tcall( string )
586          character*(*) string
587          call tsub( string )
588          end
589    EOF
590        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
591        RETVAL=$?
592        if test "x$RETVAL" != x0 ; then
593            FC_NAMEMANGLE=$default_nm
594            cat <<EOF>> genmake_warnings
595    
596    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
597    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
598    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
599    EOF
600            return 1
601        fi
602        f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603        RETVAL=$?
604        if test "x$RETVAL" != x0 ; then
605            FC_NAMEMANGLE=$default_nm
606            cat <<EOF>> genmake_warnings
607    
608    WARNING: The "nm" command failed.
609    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
610    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
611    EOF
612            return 1
613        fi
614    
615        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
616        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
617        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
618        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
619    
620        nmangle="X"
621        if test "x$c_a" != "x$f_a" ; then
622            comm="echo x$f_a | sed -e 's|x$c_a||'"
623            a=`eval $comm`
624            nmangle="$a ## $nmangle"
625        fi
626        if test "x$c_b" != "x$f_b" ; then
627            comm="echo x$f_b | sed -e 's|x$c_b||'"
628            b=`eval $comm`
629            nmangle="$nmangle ## $b"
630        fi
631    
632        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
633    
634        #  cleanup the testing files
635        rm -f genmake_tcomp.* genmake_test.*
636    }
637    
638    
639    check_HAVE_CLOC()  {
640        get_fortran_c_namemangling
641        cat <<EOF > genmake_tc_1.c
642    $FC_NAMEMANGLE
643    #include <stdio.h>
644    #include <stdlib.h>
645    #include <unistd.h>
646    #include <assert.h>
647    #include <sys/time.h>
648    void FC_NAMEMANGLE(cloc) ( double *curtim )
649    {
650     struct timeval tv1;
651     gettimeofday(&tv1 , (void *)NULL );
652     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
653     *curtim = *curtim/1.E6;
654    }
655    EOF
656        make genmake_tc_1.o >> genmake_tc.log 2>&1
657        RET_C=$?
658        cat <<EOF > genmake_tc_2.f
659          program hello
660          Real*8 wtime
661          external cloc
662          call cloc(wtime)
663          print *," HELLO WORLD", wtime
664          end program hello
665    EOF
666        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
667        RET_F=$?
668        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
669        RETVAL=$?
670        if test "x$RETVAL" = x0 ; then
671            HAVE_CLOC=t
672            DEFINES="$DEFINES -DHAVE_CLOC"
673        fi
674        rm -f genmake_tc*
675    }
676    
677    
678    check_netcdf_libs()  {
679        echo "" > genmake_tnc.log
680        cat <<EOF > genmake_tnc.for
681          program fgennc
682    #include "netcdf.inc"
683          integer iret, ncid, xid
684          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
685          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
686          iret = nf_def_dim(ncid, 'X', 11, xid)
687          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
688          iret = nf_close(ncid)
689          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
690          end
691    EOF
692        #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"
693        #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"
694        #echo "$LINK -o genmake_tnc.o $LIBS"
695        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
696            &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f  \
697            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
698        RET_COMPILE=$?
699        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
700        RETVAL=$?
701        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
702            HAVE_NETCDF=t
703        else
704            # try again with "-lnetcdf" added to the libs
705            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
706                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
707                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
708            RET_COMPILE=$?
709            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
710            RETVAL=$?
711            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
712                LIBS="$LIBS -lnetcdf"
713                HAVE_NETCDF=t
714            else
715                cat genmake_tnc.log >> genmake_warnings
716            fi
717        fi
718        rm -f genmake_tnc*
719    }
720    
721    
722    
723    ###############################################################################
724    #   Sequential part of script starts here
725    ###############################################################################
726    
727  #  Set defaults here  #  Set defaults here
728  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 291  LN= Line 732  LN=
732  S64=  S64=
733  KPP=  KPP=
734  FC=  FC=
735    #CC=gcc
736    CPP=
737  LINK=  LINK=
738  DEFINES="-DWORDLENGTH=4"  DEFINES=
739  PACKAGES=  PACKAGES=
740  ENABLE=  ENABLE=
741  DISABLE=  DISABLE=
742  MAKEFILE=  MAKEFILE=
743  MAKEDEPEND=  #MAKEDEPEND=
744  PDEPEND=  PDEPEND=
745  DUMPSTATE=t  DUMPSTATE=t
746  PDEFAULT=  PDEFAULT=
# Line 308  FOPTIM= Line 751  FOPTIM=
751  CFLAGS=  CFLAGS=
752  KFLAGS1=  KFLAGS1=
753  KFLAGS2=  KFLAGS2=
754    #LDADD=
755  LIBS=  LIBS=
756  KPPFILES=  KPPFILES=
757  NOOPTFILES=  NOOPTFILES=
758  NOOPTFLAGS=  NOOPTFLAGS=
759    MPI=
760    MPIPATH=
761    
762  # DEFINES checked by test compilation  # DEFINES checked by test compilation
763  HAVE_SYSTEM=  HAVE_SYSTEM=
764  HAVE_FDATE=  HAVE_FDATE=
765  FC_NAMEMANGLE=  FC_NAMEMANGLE=
766    HAVE_CLOC=
767    HAVE_NETCDF=
768    HAVE_ETIME=
769    
770  MODS=  MODS=
771  TOOLSDIR=  TOOLSDIR=
772  SOURCEDIRS=  SOURCEDIRS=
773  INCLUDEDIRS=  INCLUDEDIRS=
774  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
775    
776    G2ARGS=
777    BASH=
778  PWD=`pwd`  PWD=`pwd`
779  MAKE=make  MAKE=make
780  AWK=awk  AWK=awk
781  THISHOSTNAME=`hostname`  THISHOST=`hostname`
782  THISCWD=`pwd`  THISCWD=`pwd`
783  THISDATE=`date`  THISDATE=`date`
784    THISUSER=`echo $USER`
785    THISVER=
786  MACHINE=`uname -a`  MACHINE=`uname -a`
787  EXECUTABLE=  EXECUTABLE=
788  EXEHOOK=  EXEHOOK=
# Line 339  IEEE= Line 792  IEEE=
792  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
793      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
794  fi  fi
795    FS=
796    FS90=
797    
798  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
799  AD_OPTFILE=  AD_OPTFILE=
# Line 355  TAMC_EXTRA= Line 810  TAMC_EXTRA=
810    
811    
812  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
813  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
814  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
815    
816  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
817  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
818  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
819  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
820  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
821  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
822    
823  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
824  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 373  gm_s12="TAF_EXTRA TAMC_EXTRA" Line 828  gm_s12="TAF_EXTRA TAMC_EXTRA"
828  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
829  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
830    
831    cat <<EOF
832    
833    GENMAKE :
834    
835    A program for GENerating MAKEfiles for the MITgcm project.  For a
836    quick list of options, use "genmake -h" or for more detail see:
837    
838      http://mitgcm.org/devel_HOWTO/
839    
840    EOF
841    
 echo  
842  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
843  gm_local="genmake_local"  gm_local="genmake_local"
844  for i in . $MODS ; do  for i in . $MODS ; do
845      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
846          source $i/$gm_local          . $i/$gm_local
847          break          break
848      fi      fi
849  done  done
850  echo -n "  getting local config information:  "  printf "  getting local config information:  "
851  if test -e $gm_local ; then  if test -f $gm_local ; then
852      echo "using $gm_local"      echo "using $gm_local"
853      source $gm_local      . $gm_local
854      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
855      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
856  else  else
# Line 405  fi Line 869  fi
869  #done  #done
870  #parse_options  #parse_options
871  ac_prev=  ac_prev=
872  for ac_option ; do  for ac_option in $@ ; do
873    
874        G2ARGS="$G2ARGS \"$ac_option\""
875    
876      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
877      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 428  for ac_option ; do Line 894  for ac_option ; do
894          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
895              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
896                    
897          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
898              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
899          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
900              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 448  for ac_option ; do Line 914  for ac_option ; do
914          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
915              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
916                    
917            -bash | --bash)
918                ac_prev=BASH ;;
919            -bash=* | --bash=*)
920                BASH=$ac_optarg ;;
921            
922            -makedepend | --makedepend | -md | --md)
923                ac_prev=MAKEDEPEND ;;
924            -makedepend=* | --makedepend=* | -md=* | --md=*)
925                MAKEDEPEND=$ac_optarg ;;
926            
927          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
928              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
929          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
930              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
931                    
932          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
933              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
934          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
935              PLATFORM=$ac_optarg ;;              echo
936                usage
937                ;;
938                    
939          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
940              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 483  for ac_option ; do Line 961  for ac_option ; do
961          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
962              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
963    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
964  #           -cpp | --cpp)  #           -cpp | --cpp)
965  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
966  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
967  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
968                        
969            -cc | --cc)
970                ac_prev=CC ;;
971            -cc=* | --cc=*)
972                CC=$ac_optarg ;;
973            
974          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
975              ac_prev=FC ;;              ac_prev=FC ;;
976          -fc=* | --fc=*)          -fc=* | --fc=*)
977              FC=$ac_optarg ;;              FC=$ac_optarg ;;
978                    
979            -fs | --fs)
980                ac_prev=FS ;;
981            -fs=* | --fs=*)
982                FS=$ac_optarg ;;
983            
984            -fs90 | --fs90)
985                ac_prev=FS90 ;;
986            -fs90=* | --fs90=*)
987                FS90=$ac_optarg ;;
988            
989          -ieee | --ieee)          -ieee | --ieee)
990              IEEE=true ;;              IEEE=true ;;
991          -noieee | --noieee)          -noieee | --noieee)
992              IEEE= ;;              IEEE= ;;
993            
994          -mpi | --mpi)          -mpi | --mpi)
995              MPI=true ;;              MPI=true ;;
996          -nompi | --nompi)          -mpi=* | --mpi=*)
997              MPI= ;;              MPIPATH=$ac_optarg
998                MPI=true ;;
999                    
1000          -jam | --jam)  #       -jam | --jam)
1001              JAM=1 ;;  #           JAM=1 ;;
1002          -nojam | --nojam)  #       -nojam | --nojam)
1003              JAM=0 ;;  #           JAM=0 ;;
1004                    
1005          -ds | --ds)          -ds | --ds)
1006              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 552  if test -f ./.genmakerc ; then Line 1041  if test -f ./.genmakerc ; then
1041      echo      echo
1042  fi  fi
1043    
1044    #  Find the MITgcm ${ROOTDIR}
1045  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1046      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1047        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1048          ROOTDIR=".."          ROOTDIR=".."
1049      else      else
1050          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1051              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1052                  ROOTDIR=$d                  ROOTDIR=$d
1053                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1054                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1055                  break                  break
1056              fi              fi
# Line 577  if test ! -d ${ROOTDIR} ; then Line 1068  if test ! -d ${ROOTDIR} ; then
1068      exit 1      exit 1
1069  fi  fi
1070    
1071    #  Find the MITgcm ${THISVER}
1072    if test -f "${ROOTDIR}/doc/tag-index" ; then
1073        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1074    fi
1075    
1076  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1077  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1078      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 590  fi Line 1086  fi
1086  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
1087      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1088          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
1089          source "$OPTFILE"          . "$OPTFILE"
1090          RETVAL=$?          RETVAL=$?
1091          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1092              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1093              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1094              exit 1              exit 1
1095          fi          fi
# Line 606  if test "x$OPTFILE" != xNONE ; then Line 1102  if test "x$OPTFILE" != xNONE ; then
1102      fi      fi
1103  fi  fi
1104    
1105    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1106    # check_for_broken_Ff
1107    
1108  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1109  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1110      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 617  fi Line 1116  fi
1116  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
1117      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1118          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
1119          source "$AD_OPTFILE"          . "$AD_OPTFILE"
1120          RETVAL=$?          RETVAL=$?
1121          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1122              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1123              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1124              exit 1              exit 1
1125          fi          fi
# Line 633  if test "x${AD_OPTFILE}" != xNONE ; then Line 1132  if test "x${AD_OPTFILE}" != xNONE ; then
1132      fi      fi
1133  fi  fi
1134    
1135  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1136  #  and abort!  #  either set defaults or complain and abort!
1137    if test ! "x$BASH" = x ; then
1138        # add a trailing space so that it works within the Makefile syntax (see below)
1139        BASH="$BASH "
1140    fi
1141  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1142      cat <<EOF 1>&2      cat <<EOF 1>&2
1143    
# Line 645  Error: no Fortran compiler: please speci Line 1148  Error: no Fortran compiler: please speci
1148  EOF  EOF
1149      exit 1      exit 1
1150  fi  fi
1151    if test "x$CC" = x ; then
1152        CC=cc
1153    #     cat <<EOF 1>&2
1154    # Error: no C compiler: please specify using one of the following:
1155    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1156    #   2) the "-cc=XXX" command-line option
1157    #   3) the "./genmake_local" file
1158    # EOF
1159    #     exit 1
1160    fi
1161  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1162      LINK=$FC      LINK=$FC
1163  fi  fi
1164    if test "x$MAKE" = x ; then
1165        MAKE="make"
1166    fi
1167  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1168      CPP="cpp"      CPP=cpp
1169  fi  fi
1170    #EH3 === UGLY ===
1171    #  The following is an ugly little hack to check for $CPP in /lib/ and
1172    #  it should eventually be replaced with a more general function that
1173    #  searches a combo of the user's path and a list of "usual suspects"
1174    #  to find the correct location for binaries such as $CPP.
1175    for i in " " "/lib/" ; do
1176        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1177    done
1178    #EH3 === UGLY ===
1179  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1180  RETVAL=$?  RETVAL=$?
1181  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 667  EOF Line 1192  EOF
1192  else  else
1193      rm -f test_cpp      rm -f test_cpp
1194  fi  fi
1195  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
1196      MAKEDEPEND=makedepend  if test "x$LN" = x ; then
1197        LN="ln -s"
1198    fi
1199    echo "test" > genmake_test_ln
1200    $LN genmake_test_ln genmake_tlink
1201    RETVAL=$?
1202    if test "x$RETVAL" != x0 ; then
1203        cat <<EOF 1>&2
1204    
1205    Error: The command "ln -s" failed -- please specify a working soft-link
1206      command in the optfile.
1207    
1208    EOF
1209        exit 1
1210  fi  fi
1211    rm -f genmake_test_ln genmake_tlink
1212    
1213    #  Check for broken *.F/*.f handling and fix if possible
1214    check_for_broken_Ff
1215    
1216    if test ! "x$MPI" = x ; then
1217          echo "  Turning on MPI cpp macros"
1218          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1219    fi
1220    
1221  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1222  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1223  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1224        program hello        program hello
1225        call system('echo hi')        call system('echo hi')
# Line 691  else Line 1237  else
1237  fi  fi
1238  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1239    
1240  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1241  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1242        program hello        program hello
1243        CHARACTER(128) string        CHARACTER(128) string
# Line 712  else Line 1258  else
1258  fi  fi
1259  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1260    
1261  echo -n "  The name mangling convention for $FC is...  "  printf "  Do we have the etime() command using $FC...  "
 if test "x$FC_NAMEMANGLE" = x ; then  
     FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"  
 fi  
1262  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1263        subroutine tcall( string )        program hello
1264        character*(*) string        REAL*4 ACTUAL, TARRAY(2)
1265        call tsub( string )        EXTERNAL ETIME
1266          REAL*4 ETIME
1267          actual = etime( tarray )
1268          print *, tarray
1269        end        end
1270  EOF  EOF
1271  $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1272  RETVAL=$?  RETVAL=$?
1273  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" = x0 ; then
1274      cat genmake_tcomp.log >> genmake_errors      HAVE_ETIME=t
1275      echo      DEFINES="$DEFINES -DHAVE_ETIME"
1276      echo "WARNING: test compile fails -- please see \"genmake_errors\""      echo "yes"
     echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  
     echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  
1277  else  else
1278      tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      HAVE_ETIME=
1279      RETVAL=$?      echo "no"
     if test "x$RETVAL" != x0 ; then  
         echo  
         echo "WARNING: The \"nm\" command failed."  
         echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  
         echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  
     else  
         t0=`echo $tcall | sed -e 's|_tcall|_ ## X|g'`  
         nmres=`echo $t0 | sed -e 's|tcall_|X ## _|g'`  
         FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmres"  
         echo "'$FC_NAMEMANGLE'"  
     fi  
 fi  
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
1280  fi  fi
1281  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1282    
1283    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1284    check_HAVE_CLOC
1285    if test "x$HAVE_CLOC" != x ; then
1286        echo "yes"
1287    else
1288        echo "no"
1289    fi
1290    rm -f genmake_t*
1291    
1292    printf "  Can we create NetCDF-enabled binaries...  "
1293    check_netcdf_libs
1294    if test "x$HAVE_NETCDF" != x ; then
1295        echo "yes"
1296    else
1297        echo "no"
1298    fi
1299    
1300    
1301  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1302  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1303  for d in $MODS ; do  for d in $MODS ; do
1304      if test ! -d $d ; then      if test ! -d $d ; then
1305          echo          echo
1306          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1307          exit 1          exit 1
1308      else      else
1309          echo -n " $d"          printf " $d"
1310          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1311          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1312      fi      fi
# Line 777  if test "x${PLATFORM}" = x ; then Line 1321  if test "x${PLATFORM}" = x ; then
1321  fi  fi
1322    
1323  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1324      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1325        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1326          EXEDIR=../exe          EXEDIR=../exe
1327      else      else
1328          EXEDIR=.          EXEDIR=.
# Line 792  if test "x${TOOLSDIR}" = x ; then Line 1337  if test "x${TOOLSDIR}" = x ; then
1337      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1338  fi  fi
1339  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1340      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1341      exit 1      exit 1
1342  fi  fi
1343  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1344      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1345  fi  fi
1346    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1347    
1348  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1349    
# Line 806  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1352  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1352  #  they appear as regular source code  #  they appear as regular source code
1353  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1354      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1355      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1356      RETVAL=$?      RETVAL=$?
1357      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1358          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1359      else      else
1360          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1361          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1362          exit 1          exit 1
1363      fi      fi
1364  fi  fi
1365    
1366    #same for exch2
1367    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1368        echo "  Making source files in exch2 from  templates"
1369        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1370        RETVAL=$?
1371        if test "x${RETVAL}" = x0 ; then
1372            rm -f make_exch2.errors
1373        else
1374            echo "Error: problem encountered while building source files in exch2:"
1375            cat make_exch2.errors 1>&2
1376            exit 1
1377        fi
1378    fi
1379    
1380  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1381  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1382      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 843  if test ! "x${RETVAL}" = x0 ; then Line 1403  if test ! "x${RETVAL}" = x0 ; then
1403      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1404      exit 1      exit 1
1405  fi  fi
1406  source ./.pd_tmp  . ./.pd_tmp
1407  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1408    
1409  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1410  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1411  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1412  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1413  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1414      for i in "." $MODS ; do      for i in "." $MODS ; do
1415          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 862  if test "x${PDEFAULT}" = x ; then Line 1422  if test "x${PDEFAULT}" = x ; then
1422      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1423  fi  fi
1424  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1425      echo "default packages file disabled"      echo "    default packages file disabled"
1426  else  else
1427      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1428          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1429      else      else
1430          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1431          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1432          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1433          RETVAL=$?          RETVAL=$?
1434          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1435              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1436              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1437              exit 1              exit 1
1438          fi          fi
# Line 881  else Line 1440  else
1440              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1441          done          done
1442          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1443          expand_pkg_groups          RET=1
1444            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1445          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1446      fi      fi
1447  fi  fi
1448    
1449  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1450    for i in $PACKAGES ; do
1451        echo $i >> ./.tmp_pack
1452    done
1453    for i in `grep  "-" ./.tmp_pack` ; do
1454        j=`echo $i | sed 's/[-]//'`
1455        DISABLE="$DISABLE $j"
1456    done
1457  pack=  pack=
1458  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1459      addit="t"      addit="t"
# Line 903  PACKAGES="$pack" Line 1470  PACKAGES="$pack"
1470  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1471  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1472  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1473    # Test if each explicitly referenced package exists
1474  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1475      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1476        if test ! -d "$ROOTDIR/pkg/$j" ; then
1477          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1478          exit 1          exit 1
1479      fi      fi
1480      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1481  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1482  PACKAGES=  PACKAGES=
1483  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1484      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1485  done  done
1486    rm -f ./.tmp_pack
1487  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1488    
1489  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 982  while test "x$ck" != xtt ; do Line 1550  while test "x$ck" != xtt ; do
1550              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1551              exit 1              exit 1
1552          fi          fi
1553          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1554            #i=$(( $i + 1 ))
1555      done      done
1556      ck=$ck"t"      ck=$ck"t"
1557  done  done
# Line 1001  for i in $PACKAGES ; do Line 1570  for i in $PACKAGES ; do
1570      fi      fi
1571  done  done
1572    
1573    #  Build MNC templates and check for ability to build and use NetCDF
1574    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1575    RETVAL=$?
1576    if test "x$RETVAL" = x0 ; then
1577        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1578        RETVAL=$?
1579        if test "x${RETVAL}" = x0 ; then
1580            rm -f make_mnc.errors
1581        else
1582            echo "Error: problem encountered while building source files in pkg/mnc:"
1583            cat make_mnc.errors 1>&2
1584            exit 1
1585        fi
1586        if test "x$HAVE_NETCDF" != xt ; then
1587            cat <<EOF
1588    
1589  # Create a list of #define and #undef to enable/disable packages  WARNING: the "mnc" package has been enabled but tests failed to
1590  PACKAGES_DOT_H=PACKAGES_CONFIG.h    compile and/or execute NetCDF applications.  Please check that:
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
1591    
1592  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1593      2) the LIBS variable (within the 'optfile") specifies the correct
1594           NetCDF library to link against.
1595      
1596  EOF  EOF
1597        fi
1598    fi
1599    
1600    # Create a list of #define and #undef to enable/disable packages
1601    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1602  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1603  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1604  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1605  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1606  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1607  all_pack=  all_pack=
1608    DISABLED_PACKAGES=
1609  for n in $names ; do  for n in $names ; do
1610      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1611          has_pack="f"          has_pack="f"
# Line 1033  for n in $names ; do Line 1617  for n in $names ; do
1617          done          done
1618          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1619              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1620              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1621          fi          fi
1622      fi      fi
1623  done  done
1624  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1625  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1626      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1627      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1628  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1629    
1630  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1631      case $i in      case $i in
1632          aim_v23)          aim_v23)
1633              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1634              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1635              ;;              ;;
1636      esac      esac
1637  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1638    
1639  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1640    
1641  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1642  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1643  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1644      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1645  fi  fi
1646  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1647      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1648      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1649          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1650          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1651          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1652      else              exit 1
1653          SOURCEDIRS="$SOURCEDIRS $adr"          else
1654      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1655      adr="$ROOTDIR/$d/inc"          fi
1656      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1657          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1658          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1659          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1660      else              exit 1
1661          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1662      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1663  done          fi
1664        done
1665    fi
1666    
1667  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1668  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1669  CPP_OPTIONS=  CPP_OPTIONS=
1670    CPP_EEOPTIONS=
1671  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1672    names=`ls -1 "$ROOTDIR/pkg"`
1673  for i in $spaths ; do  for i in $spaths ; do
1674      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1675      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1676          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1677          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1678          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1679            for n in $names ; do
1680                test_for_package_in_cpp_options $CPP_OPTIONS $n
1681            done
1682        fi
1683        try="$i/CPP_EEOPTIONS.h"
1684        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1685            echo "    found CPP_EEOPTIONS=\"$try\""
1686            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1687    #**** not yet enabled ****
1688    #        test_for_mpi_in_cpp_eeoptions $try
1689    #**** not yet enabled ****
1690            CPP_EEOPTIONS="$try"
1691      fi      fi
1692  done  done
1693  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1694      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1695      exit 1      exit 1
1696  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1697    
1698  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1699  #  compiler.  #  compiler.
# Line 1136  for i in $SOURCEDIRS ; do Line 1708  for i in $SOURCEDIRS ; do
1708      done      done
1709  done  done
1710    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1711    
1712  echo  echo
1713  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1714  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1715  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1716      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1717          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1718      fi      fi
1719  done  done
# Line 1164  rm -rf .links.tmp Line 1723  rm -rf .links.tmp
1723  mkdir .links.tmp  mkdir .links.tmp
1724  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1725  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1726  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1727  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1728  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1729  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1730  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1731  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1732  for d in $alldirs ; do  for d in $alldirs ; do
1733      deplist=      deplist=
# Line 1177  for d in $alldirs ; do Line 1736  for d in $alldirs ; do
1736      for sf in $sfiles ; do      for sf in $sfiles ; do
1737          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1738              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1739                    case $d/$sf in
1740                      ./$PACKAGES_DOT_H)
1741                            ;;
1742                      ./AD_CONFIG.h)
1743                            ;;
1744                      ./FC_NAMEMANGLE.h)
1745                            ;;
1746                      ./BUILD_INFO.h)
1747                            ;;
1748                      *)
1749                            touch .links.tmp/$sf
1750                            deplist="$deplist $sf"
1751                            ;;
1752                    esac
1753                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1754                  case $extn in                  case $extn in
1755                      F)                      F)
1756                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1757                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1758                          ;;                          ;;
1759                      F90)                      F90)
1760                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1761                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1762                          ;;                          ;;
1763                      c)                      c)
1764                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1765                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1766                          ;;                          ;;
1767                      h)                      h)
1768                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1769                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1770                          ;;                          ;;
1771                      flow)                      flow)
1772                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1773                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1774                          ;;                          ;;
1775                  esac                  esac
1776              fi              fi
# Line 1219  echo "" >> f90srclist.inc Line 1790  echo "" >> f90srclist.inc
1790  echo "" >> hlist.inc  echo "" >> hlist.inc
1791  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1792    
1793  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1794      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1795  fi  fi
1796  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1228  echo "#    $MACHINE" >> $MAKEFILE Line 1799  echo "#    $MACHINE" >> $MAKEFILE
1799  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1800  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1801  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1802  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1803  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1804  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1805    
1806  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
1807  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
1808  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1809    
1810  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1811    #
1812    # OPTFILE="$OPTFILE"
1813  #  #
1814  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1815  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1270  EXE_AD      = ${EXE_AD} Line 1843  EXE_AD      = ${EXE_AD}
1843  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1844  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1845    
1846    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1847    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1848    
1849    # These files are created by Makefile
1850    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1851    
1852  EOF  EOF
1853    
1854  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1287  KPP = ${KPP} Line 1866  KPP = ${KPP}
1866  FC = ${FC}  FC = ${FC}
1867  # Fortran compiler  # Fortran compiler
1868  F90C = ${F90C}  F90C = ${F90C}
1869    # C compiler
1870    CC = ${CC}
1871  # Link editor  # Link editor
1872  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1873    
1874  # Defines for CPP  # Defines for CPP
1875  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1320  cat csrclist.inc      >> $MAKEFILE Line 1901  cat csrclist.inc      >> $MAKEFILE
1901  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1902  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1903  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1904  echo               >> $MAKEFILE  echo >> $MAKEFILE
1905  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1906  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1907  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1908    echo >> $MAKEFILE
1909    echo '.SUFFIXES:' >> $MAKEFILE
1910    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1911  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1912  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1913    
1914  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1915    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1916  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1917  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1918            @echo Creating \$@ ...
1919          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1920  depend:  depend:
1921          @make links          @make links
1922          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1923          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1924            -rm -f makedepend.out
1925    
1926  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1927    
1928  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1929    
# Line 1350  output.txt: \$(EXECUTABLE) Line 1932  output.txt: \$(EXECUTABLE)
1932          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1933    
1934  clean:  clean:
1935          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1936  Clean:  Clean:
1937          @make clean          @make clean
1938          @make cleanlinks          @make cleanlinks
1939          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1940            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1941  CLEAN:  CLEAN:
1942          @make Clean          @make Clean
1943          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1944          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1945          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1946          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1947    
1948  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1949  makefile:  makefile:
1950          ${0} $@          $THIS_SCRIPT $G2ARGS
1951  cleanlinks:  cleanlinks:
1952          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1953    
1954  # The normal chain of rules is (  .F - .f - .o  )  # Special targets (SPECIAL_FILES) which are create by make
1955  .F.f:  ${PACKAGES_DOT_H}:
1956            @echo Creating \$@ ...
1957            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1958    AD_CONFIG.h:
1959            @echo Creating \$@ ...
1960            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1961    FC_NAMEMANGLE.h:
1962            @echo Creating \$@ ...
1963            echo "$FC_NAMEMANGLE" > \$@
1964    
1965    BUILD_INFO.h:
1966            @echo Creating \$@ ...
1967    EOF
1968    
1969    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
1970    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
1971    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
1972    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
1973    
1974    cat >>$MAKEFILE <<EOF
1975    
1976    # The normal chain of rules is (  .F - .$FS - .o  )
1977    
1978    %.o : %.F
1979    
1980    .F.$FS:
1981          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1982  .f.o:  .$FS.o:
1983          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1984  .F90.f90:  .F90.$FS90:
1985          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1986  .f90.o:  .$FS90.o:
1987          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1988  .c.o:  .c.o:
1989          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1990    
1991  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1992  .F.p:  .F.p:
1993          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1994  .p.f:  .p.$FS:
1995          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1996    
1997  #=========================================  #=========================================
# Line 1411  done Line 2018  done
2018    
2019  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2020  echo >> $MAKEFILE  echo >> $MAKEFILE
2021  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2022  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2023  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2024      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2025      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2026  done  done
2027  echo >> $MAKEFILE  echo >> $MAKEFILE
2028  rm -f ad_files  rm -f ad_files
# Line 1428  adtaf: ad_taf_output.f Line 2035  adtaf: ad_taf_output.f
2035  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
2036    
2037  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2038            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2039          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2040            -rm -f ad_config.template
2041          @make \$(F77FILES)          @make \$(F77FILES)
2042          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2043          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
2044    
2045  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
2046          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2047          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2048    
2049    adtafonly:
2050            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2051            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2052    
2053  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
2054          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2055    
2056  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
2057          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
2058          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
2059    
2060  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2061          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1454  ftltaf: ftl_taf_output.f Line 2067  ftltaf: ftl_taf_output.f
2067  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
2068    
2069  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2070            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2071          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2072            -rm -f ftl_config.template
2073          @make \$(F77FILES)          @make \$(F77FILES)
2074          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2075          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
2076    
2077  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
2078          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2079          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2080    
2081    ftltafonly:
2082            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2083            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2084    
2085  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2086          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2087    
2088  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
2089          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
2090          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
2091    
2092  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2093          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2094    
2095    
2096  # ... SVD ...  # ... SVD ...
2097  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
2098  svd_taf_f: svd_taf_output.f  svdall: svd_taf
   
 svd_input_code.f: \$(SRCFILES)  
         cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h  
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
   
 svd_taf_output.f: svd_input_code.f  
         \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f  
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
2099    
2100  svd_taf: svd_taf_output.o \$(OBJFILES)  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
2101          \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2102    
2103    
2104  #=========================================  #=========================================
# Line 1507  for i in $KPPFILES ; do Line 2116  for i in $KPPFILES ; do
2116      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2117          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2118      fi      fi
2119      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2120  done  done
2121    
2122  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1517  for i in $NOOPTFILES ; do Line 2126  for i in $NOOPTFILES ; do
2126      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2127          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2128      fi      fi
2129      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2130      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2131  done  done
2132    
# Line 1530  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2139  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2139    
2140  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2141    
2142  #  Write the "template" files for the adjoint builds  # Create special header files
2143  cat >AD_CONFIG.template <<EOF  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2144  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
2145  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2146  C    unless you are CERTAIN that you know what you are doing.  else
2147        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2148  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
2149  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
2150  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
2151  EOF      else
2152  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2153  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2154  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
2155  C    unless you are CERTAIN that you know what you are doing.  fi
2156    if test ! -f AD_CONFIG.h ; then
2157  #define ALLOW_ADJOINT_RUN      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2158  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
2159    
2160    
2161  #  Write the "state" for future records  #  Write the "state" for future records
2162  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2163      echo -n "" > genmake_state      printf "" > genmake_state
2164      for i in $gm_state ; do      for i in $gm_state ; do
2165          t1="t2=\$$i"          t1="t2=\$$i"
2166          eval $t1          eval $t1

Legend:
Removed from v.1.30  
changed lines
  Added in v.1.98

  ViewVC Help
Powered by ViewVC 1.1.22